MPI_Comm_get_attr(3)

NAME
MPI_Comm_get_attr - Retrieves attribute value by key.

SYNTAX

C Syntax
#include <mpi.h>
int MPI_Comm_get_attr(MPI_Comm comm, int comm_keyval,
	void *attribute_val, int *flag)

Fortran Syntax (see FORTRAN 77 NOTES)
INCLUDE 'mpif.h'
MPI_COMM_GET_ATTR(COMM, COMM_KEYVAL, ATTRIBUTE_VAL, FLAG, IERROR)
	INTEGER	COMM, COMM_KEYVAL, IERROR
	INTEGER(KIND=MPI_ADDRESS_KIND) ATTRIBUTE_VAL
	LOGICAL FLAG

C++ Syntax
#include <mpi.h>
bool MPI::Comm::Get_attr(int comm_keyval, void* attribute_val)
	const

INPUT PARAMETERS

comm
    Communicator to which the attribute is attached (handle).

comm_keyval
    Key value (integer).

OUTPUT PARAMETER

attribute_val
    Attribute value, unless flag = false.

flag
    False if no attribute is associated with the key (logical).

IERROR
    Fortran only: Error status (integer).

DESCRIPTION
MPI_Comm_get_attr retrieves an attribute value by key. The call is erroneous if there is no key with value keyval. On the other hand, the call is correct if the key value exists, but no attribute is attached on comm for that key; in that case, the call returns flag = false. In particular, MPI_KEYVAL_INVALID is an erroneous key value.

This function replaces MPI_Attr_get, the use of which is deprecated. The C binding is identical. The Fortran binding differs in that attribute_val is an address-sized integer.

FORTRAN 77 NOTES
The MPI standard prescribes portable Fortran syntax for the ATTRIBUTE_VAL argument only for Fortran 90. Sun FORTRAN 77 users may use the non-portable syntax

     INTEGER*MPI_ADDRESS_KIND ATTRIBUTE_VAL

where MPI_ADDRESS_KIND is a constant defined in mpif.h and gives the length of the declared integer in bytes.

ERRORS
Almost all MPI routines return an error value; C routines as the value of the function and Fortran routines in the last argument. C++ functions do not return errors. If the default error handler is set to MPI::ERRORS_THROW_EXCEPTIONS, then on error the C++ exception mechanism will be used to throw an MPI:Exception object.

Before the error value is returned, the current MPI error handler is called. By default, this error handler aborts the MPI job, except for I/O function errors. The error handler may be changed with MPI_Comm_set_errhandler; the predefined error handler MPI_ERRORS_RETURN may be used to cause error values to be returned. Note that MPI does not guarantee that an MPI program can continue past an error.